local version = "1.7"

--[[
 Halo 3 & Halo 4 © Microsoft Corporation. Killing Streaks was created under Microsoft's "Game Content Usage Rules" using assets from Halo 3 & Halo 4. It is not endorsed by Microsoft and does not reflect the views or opinions of Microsoft or anyone officially involved in producing or managing Halo 3 and/or Halo 4.  As such, it does not contribute to the official narrative of the fictional universe, if applicable.
 
 Used with permission from Microsoft.
 
 Required Link to Rules:
 http://www.xbox.com/en-US/Community/Developer/Rules
]]

local HKSF = CreateFrame("Frame")

LibStub("AceTimer-3.0"):Embed(HKSF)
LibStub("AceEvent-3.0"):Embed(HKSF)
LibStub("AceConsole-3.0"):Embed(HKSF)
--LibStub("ChatThrottleLib"):Embed(HKSF)
LibStub("AceComm-3.0"):Embed(HKSF)

local commPrefix = "HKSF"
local killcount = 0
local killstreak = 0
local TimerHandle
local MusHandle = -1

function HKSF:StreakEnded()
	if killcount >= 2 then
		print("\124cFFFF0000Timed Killing Streak Ended")
	end
	killcount = 0
	MusHandle = -1
end

function HKSF:StopPlaying()
	StopSound(MusHandle)
	MusHandle = -1
end

function HKSF:Input(arg1)
	--print("Debug:"..arg1)
	ksArg1, ksArg2, ksArg3, ksArg4 = HKSF:GetArgs(arg1, 4, 1) 
	if ksArg1 ~= nil then
		-- We have arguments to work with... Lets sort them out:
		if string.lower(ksArg1) == "test" then
			if string.lower(ksArg2) == "ks" then
				-- Play KillStreak sound for the given number
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..ksArg3..".mp3");
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif string.lower(ksArg2) == "kc" then
				-- Play Killcount sound for the given number
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..ksArg3..".mp3");
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif string.lower(ksArg2) == "killstreak" then
				print(killstreak)
			elseif string.lower(ksArg2) == "killstreakrecord" then
				print(KillStreakRecord)
			end
		elseif string.lower(ksArg1) == "killstreak" then
			if string.lower(ksArg2) == "show" then
				if string.lower(ksArg3) == "streak" then
					print("Current Killstreak Count: "..killstreak)
				elseif string.lower(ksArg3) == "record" then
					print("Current Killstreak Record: "..KillStreakRecord)
				end
			elseif string.lower(ksArg2) == "report" then
				local _record
				if KillStreakRecord > killstreak then
					_record = KillStreakRecord
				else
					_record = killstreak
				end
				-- Print based on channel included in ksArg3(3rd command)
				if string.lower(ksArg3) == "say" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "SAY", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "party" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "PARTY", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "guild" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "GUILD", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "raid" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "RAID", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "bg" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "BATTLEGROUND", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "whisper" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "WHISPER", nil, ksArg4)
				end
			end
		elseif string.lower(ksArg1) == "reset" then
			killstreak = 0
			print("Killstreak Reset")
		end
	end
end

function CheckKillsPlaySound(killcount, killstreak)
	if killcount > 1 then
		if HKSF:TimeLeft(TimerHandle) > 0 then
			if killcount == 2 then
				-- Double Kill | 2 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
				print("\124cFF79CDCDDouble Kill!")
			elseif killcount == 3 then
				-- Triple Kill | 3 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDTriple Kill!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
				-- Overkill | 4 kills within 4 seconds of each other.
			elseif killcount == 4 then
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDOverkill!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif killcount == 5 then
				-- Killtacular | 5 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltacular!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif killcount == 6 then
				-- Killtrocity | 6 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltrocity!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif killcount == 7 then
				-- Killimanjaro | 7 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillimanjaro!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif killcount == 8 then
				-- Killtastrophe | 8 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltastrophe!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif killcount == 9 then
				-- Killpocalypse | 9 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillpocalypse!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			elseif killcount == 10 then
				-- Killionaire | 10 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillionaire!")
				StopSound(MusHandle)
				willPlay, MusHandle = PlaySoundFile(soundfile)
			end
		end
	elseif killstreak > 1 and HKSF:TimeLeft(TimerHandle) > 0 then
		if killstreak == 5 then
			-- Killing Spree | Kill 5 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDKilling Spree!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		elseif killstreak == 10 then
			-- Killing Frenzy | Kill 10 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDKilling Frenzy!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		elseif killstreak == 15 then
			-- Running Riot | Kill 15 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDRunning Riot!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		elseif killstreak == 20 then
			-- Rampage | Kill 20 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDRampage!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		elseif killstreak == 25 then
			-- Untouchable | Kill 25 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDUntouchable!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		elseif killstreak == 30 then
			-- Invincible | Kill 30 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDInvincible!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		elseif killstreak == 35 then
			-- Inconceivable | Kill 35 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDInconceivable!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		elseif killstreak == 40 then
			-- Unfriggenbelievable | Kill 40 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDUnfriggenbelievable!")
			StopSound(MusHandle)
			willPlay, MusHandle = PlaySoundFile(soundfile)
		end
	end
end

function HKSF:OnCombatEvent(eventName, timestamp, event, _, sourceGUID, sourceName, _, _, destGUID, destName)
	--print("Event Name:"..eventName.." | Subevent:"..event.." | Killcount:"..killcount.." | Killstreak:"..killstreak)
	-- Debug:
	--[[if event == "PARTY_KILL" then
		print("Dest GUID:"..destGUID..", Source GUID:"..sourceGUID..",Event:"..event..", Player GUID:"..UnitGUID("player"))
	end]]
	if (event == "PARTY_KILL" and sourceGUID == UnitGUID("player")) then
		HKSF:CancelTimer(TimerHandle)
		TimerHandle = HKSF:ScheduleTimer("StreakEnded", 4)
		killcount = killcount + 1
		killstreak = killstreak + 1
		CheckKillsPlaySound(killcount, killstreak)
	elseif (event == "UNIT_DIED" and UnitIsDeadOrGhost("player") == 1 and destGUID == UnitGUID("player")) then
		if killstreak > 0 then
			print("Killing Streak Ended")
			if killstreak > KillStreakRecord then
				-- New Kill Record. Save it for bragging rights.
				KillStreakRecord = killstreak
				print("New Streak Record of "..killstreak.." kills.")
			end
			killstreak = 0
		end
	end
end

function HKSF:OnEnterWorld(event, arg1, ...)
	if arg1 == "KillingStreaks" then
		HKSF:RegisterComm(commPrefix, "OnCommEvent")
		if KillStreakRecord == nil then
			-- First time loading addon
			KillStreakRecord = 0
		end
		if IsInGuild() then
			HKSF:SendCommMessage(commPrefix, version, "GUILD")
		end
		print("Killing Streaks \124cFFFF0000"..version.." \124cffFFFFFFLoaded");
		print("[Killing Streaks] Note: Compatibility with patch 6.0+ not yet fully confirmed working at this point.")
	end
end

function HKSF:OnCommEvent(prefix, message, distribution, sender)
	--print(message)
	if strfind(version, message) ~= 1 then
		-- Versions dont match check versions
		if tonumber(message) > tonumber(version) then
			print("Your addon is out of date... Please download the latest version.")
			RaidNotice_AddMessage(RaidWarningFrame, "Your addon is out of date... Please download the latest version.", ChatTypeInfo["RAID_WARNING"])
		end
	end
end

function HKSF:OnEnable()
	
end

function HKSF:OnParty()
	--local t1 = UnitInBattleground("player")
	local t2 = IsInGroup()
	local t3 = IsInRaid()
	--print(tostring(t2))
	--print(tostring(t3))
	
	--if t1 == true then
		--Send BG Check
		--HKSF:SendCommMessage(commPrefix, version, "BATTLEGROUND")
	--elseif t2 == true and t3 == false then
	if t2 == true and t3 == false then
		--Send Party Check
		--print("Party Sent")
		HKSF:SendCommMessage(commPrefix, version, "PARTY")
	elseif t3 == true then
		--Send Raid Check
		--print("Raid Sent")
		HKSF:SendCommMessage(commPrefix, version, "RAID")
	end
	--Else do nothing as they arent in a valid group to version check or something.
	
	-- print("Debug: Joined a Party/Raid/BG")
end

HKSF:RegisterChatCommand("ks", "Input", true);
HKSF:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent");
HKSF:RegisterEvent("ADDON_LOADED", "OnEnterWorld");
HKSF:RegisterEvent("GROUP_ROSTER_UPDATE", "OnParty");
--HKSF:SetScript("OnEvent", function(timestamp, event, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)

